/***********************************************************************************
                         anselm.ru [2015-02-26] GNU GPL
***********************************************************************************/
#pragma once

#include <expat.h>
#include <string>
#include <stack>
using namespace std;

class SAX {
friend void XMLCALL startElement(void *data, const char *el, const char **attr);
friend void XMLCALL endElement(void *data, const char *el);
friend void XMLCALL characterData(void *data, const XML_Char *s, int len);
public:
  SAX();
  virtual ~SAX();
  bool parse(const char* buf);
  
  void reset();
  int depth() const;
  SAX& operator<< (const string&);
protected:
  virtual void attr(const char* name, const char* value);
  virtual void tag(const char* name, const char* value);
  virtual void tag_start(const char* name) {}
  virtual void tag_end(const char* name) {}
  virtual void doc_start() {}
  virtual void doc_end() {}
  virtual void header(const char*);
  void trim(string&) const;
  XML_Index ind() const;
  XML_Size col() const;
  XML_Size line() const;
private:
  bool parse_expat(const char* buf, size_t len);
  typedef enum {
    NONE_DOCUMENT,
    START_DOCUMENT,
    END_DOCUMENT
  } STATE;
  XML_Parser d_parser;
  stack<string> d_stack;
  int d_depth;
  string d_header, d_cache;
  STATE d_state;
};
